<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import _ from "lodash";
@Component({})
export default class AdminShopCouponComponent extends Vue {
  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  page = 1;
  totalPage: number = 0;

  dialogDelete = false;
  dialogDeleteList = false;
  selectedAll = false;
  loadingTable = false;
  loading = false;
  loadingId: any = "";
  editId = "";
  idxAdd: any = null;
  couponId = "";

  listCoupon: any = [];
  listIds = [];
  listTypeCoupon = [
    { name: "Percent", value: 1 },
    { name: "Money", value: 2 },
  ];

  mounted() {
    this.onGetListCoupon();
  }

  async onGetListCoupon() {
    try {
      this.loadingTable = true;
      const response = await this.$api.coupon.list(this.config);
      const { page, total, totalInList, data } = response.data;
      this.totalPage = Math.ceil(total / this.config.limit);
      if (response?.data?.data) {
        this.listCoupon = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  addCoupon() {
    this.listCoupon.push({
      name: "Coupon",
      type: 1,
      value: 0,
      isUsing: true,
    });
  }

  async onHandlerCoupon(id: any) {
    try {
      const findCoupon = this.listCoupon.find(
        (coupon: any, i: number) => coupon._id === id || i === id
      );
      this.loadingId = id;
      const { name, type, value, isUsing, _id } = findCoupon;
      if (!name) {
        return this.$pushNotification.error("Name cannot be left blank");
      } else if (!value) {
        return this.$pushNotification.error(
          "Coupon value cannot be less than 0"
        );
      }
      const payload = {
        name,
        type,
        value,
        isUsing,
      };
      if (_id) {
        await this.$api.coupon.edit(_id, payload);
        this.$pushNotification.success("Updated coupon successfully");
      } else {
        await this.$api.coupon.create(payload);
        this.$pushNotification.success("Created coupon successfully");
      }
      this.onGetListCoupon();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingId = null;
      this.editId = "";
    }
  }

  removeCoupon(i: number) {
    this.listCoupon.splice(i, 1);
  }
  openDialogDelete(id: any) {
    if (typeof id === "string") {
      this.couponId = id;
      this.dialogDelete = true;
    } else {
      this.removeCoupon(id);
    }
  }
  async onDeleteCoupon() {
    try {
      this.loading = true;
      await this.$api.coupon.delete(this.couponId);
      this.$pushNotification.success("Deleted coupon successfully");
      this.dialogDelete = false;
      this.onGetListCoupon();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
  openDialogDeleteListCoupon() {
    if (!this.listIds.length) {
      return this.$pushNotification.success("Please select coupon list");
    }
    this.dialogDeleteList = true;
  }
  async onDeleteListCoupon() {
    try {
      this.loading = true;
      await this.$api.coupon.deleteList(this.listIds);
      this.$pushNotification.success("Deleted list coupon successfully");
      this.dialogDeleteList = false;
      this.listIds = [];
      this.selectedAll = false;
      this.onGetListCoupon();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onChangeStatus(coupon: any) {
    const { name, type, value, isUsing, _id } = coupon;
    const payload = {
      name,
      type,
      value,
      isUsing,
    };
    try {
      await this.$api.coupon.edit(_id, payload);
      this.$pushNotification.success("Changed status successfully");
      this.onGetListCoupon();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  convertImg(product: any) {
    if (product?.coverId?.imageUrl) {
      return `${api}/${product.coverId.imageUrl}`;
    }
    return "";
  }

  calcPrice(product: any) {
    let price = 0;
    if (product.variant.length) {
      for (let variant of product.variant) {
        price += variant.price;
      }
    } else {
      return product.price;
    }
    return price;
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListCoupon();
  }

  @Watch("config.search")
  changedSearch(val: string) {
    if (!val) {
      this.onGetListCoupon();
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListCoupon();
  }

  @Watch("selectedAll")
  async onSelectAllChanged(value: string, oldValue: string) {
    if (value) {
      const listIds = [...this.listIds];
      //@ts-ignore
      const selectedCurrentCoupon = this.listCoupon
        //@ts-ignore
        .map((coupon) => coupon._id)
        //@ts-ignore
        .filter((id) => !listIds.includes(id));
      //@ts-ignore
      this.listIds = [...listIds, ...selectedCurrentCoupon];
    } else {
      //@ts-ignore
      const selectedCurrentCoupon = this.listCoupon
        //@ts-ignore
        .map((coupon) => coupon._id);
      this.listIds = this.listIds.filter(
        (c) => !selectedCurrentCoupon.includes(c)
      );
    }
  }
}
</script>

<style>
.bg-img {
  background: rgba(72, 84, 91, 0.64);
  border: 1px solid #edeeef;
  border-radius: 8px;
  padding: 6px;
}
</style>
